Subject: Re: [OSPF] AD review of draft-ietf-ospf-encapsulation-cap-03

From: "Carlos Pignataro (cpignata)" <[email-masked]>
Date: Tue, 4 Jul 2017 00:23:17 +0000

Xiaohu, Bruno,

I agree with not creating a new IANA registry and reusing “BGP Tunnel Encapsulation Attribute Tunnel Types”, with the pointer to RFC 5512 and not a future hypothetical — I would add RFC 5566 as well perhaps, though.

I do have one additional comment, however. One useful property of the softwire signaling is the ability to define ECMP characteristics, as per RFC 5640. Yet https://tools.ietf.org/html/draft-ietf-ospf-encapsulation-cap-05#section-8.2 does not define that type.

I’d encourage you to add the “Load-Balancing Block” with functionality as per RFC 5640 to have a more comprehensive approach signaled.

Thanks!

Carlos.

On Jun 19, 2017, at 9:19 PM, Xuxiaohu <[email-masked]<mailto:[email-masked]>> wrote:

Hi Alia,

Thanks a lot for your AD review. Please see our response inline.

发件人: Alia Atlas [mailto:[email-masked]]
发送时间: 2017年6月15日 6:56
收件人: OSPF List; [email-masked]<mailto:[email-masked]>
主题: AD review of draft-ietf-ospf-encapsulation-cap-03

As is customary, I have done my AD review of draft-ietf-ospf-encapsulation-cap-03.
First, I would like to thank the authors - Xiaohu, Bruno, Robert, Luis, and Luay - for their work on this useful document.

I do have a few concerns that need addressing before the draft can progress.

[Bruno/Xiaohu] Many thanks for your useful comments.
Following your comments, we believe it would be simpler and better to not create a new IANA registry for ”IGP  Tunnel Encapsulation Attribute Types” but rather reuse the existing BGP one:
https://www.iana.org/assignments/bgp-parameters/bgp-parameters.xhtml#tunnel-types

[Bruno/Xiaohu] BTW when this OSPF extension has been defined, it has been modeled based on RFC 5512. However, as of today, the BGP extension is been redefined in draft-ietf-idr-tunnel-encaps, sometimes. Which normative reference should be use?
- as of today, RFC 5512 is probably the right one as draft-ietf-idr-tunnel-encaps has not passed WG LC and may never be published as RFC (IDR requires 2 implementations. I think RFC 5512 has not been implemented hence we may question whether draft-ietf-idr-tunnel-encaps will be…)
- in some hypothetical future, draft-ietf-idr-tunnel-encaps may obsolete RFC 5512

Major:

1)  First, the draft talks about what information is sent - but nothing about how it is to be understood or used.  That'd be ok if there were a clear reference to a document that discussed the related procedures.  A quick scan of draft-ietf-idr-tunnel-encaps-06 seems that it may be the right place to start - but it's procedures are BGP-focused and while there are many similarities, there may be interesting differences as well.

[Bruno/Xiaohu] We’ll clarify that the 3 sub-TLV (§5.1-§5.3) are normatively defined in RFC 5512, from a format, semantic and usage standpoint. And that there code point are allocated in respectively the following IANA registries: BGP Tunnel Encapsulation Attribute Tunnel Types, BGP Tunnel Encapsulation Attribute Sub-TLVs. As per you comment, we need to clarify the 5.4 color Sub-TLV. Proposed text:
The Color Sub-TLV value is a 4-octet unsigned integer. Its semantic and usage are the same as the Color Value, from the Color Sub-TLV defined in RFC 5512 section 4.3 (*)

For instance, for the Color sub-TLV, is the 4 byte color value expected to represent the same meaning in OSPF as in BGP?

[Bruno/Xiaohu]Yes.

  Can a BGP route with a particular color extended community then have the OSPF tunnel to use selected from only those tunnels with the same color?

  What does the Color TLV mean in a purely OSPF context?

[Bruno/Xiaohu] idem as in the IDR context.  It’s a color used to define policy. The application using those tunnels, may use this color as an input for its policy when choosing the tunnel to use (or not use).
We can add this text if needed.

  Sec 7 of draft-ietf-idr-tunnel-encaps-06 ("However, suppose that one of the TLVs in U2's Tunnel Encapsulation attribute contains the Color Sub-TLV.  In that case, packet P SHOULD
   NOT be sent through the tunnel identified in that TLV, unless U1 is
   carrying the Color Extended Community that is identified in U2's
   Color Sub-TLV.") doesn't seem to strictly apply.

[Bruno/Xiaohu] Would new clarification added above (*) be enough? If not, a priori, I’d rather improve the definition of section 5.4 defining this color sub-TLV, in order for it to generally apply to any text. (rather than trying to patch the specific above text from Sec 7)

Semantics and behavior need to be specified - not just the encodings, and that is all this draft currently has.

2)  Sec 5.1 and Sec 5.2 refer to the format of the Encapsulation Sub-TLV and Protocol Sub-TLV coming from draft-ietf-idr-tunnel-encaps-06 - but that draft defines not merely the format, but allocates an IANA registry for additional sub-types that can appear and defines the format and contents of the sub-TLV based upon the tunnel type.   I'm nearly certain that you mean that these sub-tlvs use not merely the same format (does variable length fields based upon the allocated type cause issues for OSPF sub-TLV parsing???) but can contain any values and sub-TLVs defined in the relevant IANA registry. As it is written now, there is no reference to the registry or ability to easily support more tunnel types in the future.

[Bruno/Xiaohu] Good point. Does the previous change address that point?

3) It is unfortunate that Geneve, which is the agreed encapsulation for NVO3, is not included in the set of tunnels but VXLAN-GPE, which is not going to be a standard, is.
I know this is duplicating what is in draft-ietf-idr-tunnel-encaps-06 but it emphasizes the need to assume additional Tunnel Types and related Encapsulation Sub-TLVs will be defined.

[Bruno/Xiaohu] I agree that this is unfortunate.
But as the this new change, this draft will just refer to the existing BGP tunnels types. No duplication, no new tunnel types.
I’d rather define new types in an independent document. Home of this document, and possibly additional WGs to cross-post, would already be a good question ;-) (candidates could be OSPF, IS-IS, IDR, NVO3, RTGWG, softwires, possibly BESS…)

4) Sec 4: Is there a reason to create a new IGP Tunnel Encapsulation Types registry instead of reusing BGP Tunnel Encapsulation Attribute Tunnel Types (https://www.iana.org/assignments/bgp-parameters/bgp-parameters.xhtml#tunnel-types)?  The latter is FCFS and the proposed registry is Standards Action.   There are already differences and collisions between the two (i.e. value 15).
What would happen if an Encapsulation Sub-TLV needed to include a Tunnel Type? Which registry would it pull from? Would the value used depend on the protocol it was signaled in?

[Bruno/Xiaohu] Not anymore. (in early version of the OSPF draft, the code point was 1 octet, while IDR was 2). As indicated above, we’ll change to use the BGP one.

5) I-D.ietf-idr-tunnel-encaps has to be a normative reference.

[Bruno/Xiaohu] see the above.

6) Given that some of the references are to in progress documents for the tunnel types, is it expected that the values will correspond to future versions or are they nailed to this particular version or something else?

[Bruno/Xiaohu] I think the reference to existing “BGP”/IANA registry address this point

Nits:

a) Sec 1:"Partial deployment of IPv6 in IPv4 networks or IPv6 in IPv4
      networks as described in [RFC5565]"
s/IPv6 in IPv4/IPv4 in IPv6 for one of the two

[Bruno/Xiaohu] will fix it. Thanks again for your detailed AD review of this doc.

Regards,
Alia

Best regards,
Xiaohu/Bruno

_______________________________________________
OSPF mailing list
[email-masked]<mailto:[email-masked]>
https://www.ietf.org/mailman/listinfo/ospf

—
Carlos Pignataro, [email-masked]<mailto:[email-masked]>

“Sometimes I use big words that I do not fully understand, to make myself sound more photosynthesis."